<?php
$controls = '';
$head = '';
$this->replaceTvButtons();
if($modx->directParse==1) {
    return;
}

if($modx->documentObject['contentType']!=='text/html') {
    return;
}
if($modx->documentObject['content_dispo']==='1') {
    return;
}

$manager_language = $modx->conf_var('manager_language');

// Include default language
include_once(MODX_CORE_PATH . 'lang/english.inc.php');

$user_lang_path = MODX_CORE_PATH . 'lang/' . $manager_language . '.inc.php';
if($manager_language !== 'english' && is_file($user_lang_path)) {
    include_once $user_lang_path;
}

// Get document id
$docID = $modx->documentIdentifier;

// Get page output
$output = &$modx->documentOutput;

// Close modal box after saving (previously close.php)
if ($modx->input_get('quickmanagerclose')) {
    // Set url to refresh
    $url = $modx->makeUrl($modx->documentIdentifier);
    exit(sprintf("<script>parent.location.href='%s';</script>",$url));
}

// QM+ TV edit
if((int)$modx->input_get('quickmanagertv')==1 && $modx->input_get('tvname') && $this->tvbuttons) {
    $output = include('edit_tv.inc');
//                    break;
}

// QM+ with toolbar
if ($modx->session_var('mgrValidated') && $modx->input_any('z') != 'manprev') {
    // If logout break here
    if($modx->input_any('logout')) {
        $this->Logout();
        return;
    }

    // Edit button

    // Check if user has manager access to current document
    $access = $this->checkAccess();

    // Does user have permissions to edit document
    if($access) {
        $controls .= $this->getView('buttons/edit_button.tpl', array('docID'=>$docID));
    }

    if ($this->addbutton && $access) {
        // Does user have permissions to add document
        if($modx->hasPermission('new_document')) {
            $controls .= $this->getView('buttons/add_button.tpl', array('docID'=>$docID));
        }
    }

    // Custom add buttons if not empty and enough permissions
    if ($this->custombutton != '') {
        // Handle [~id~] links
        $this->custombutton = $modx->rewriteUrls(
            $modx->evalSnippets(
                $modx->mergeChunkContent(
                    $modx->mergeSettingsContent(
                        $modx->mergeDocumentContent($this->custombutton)
                    )
                )
            )
        );

        $buttons = explode('||', $this->custombutton); // Buttons are divided by "||"

        // Custom buttons class index
        $i = 0;
        // Parse buttons
        foreach($buttons as $key => $field) {
            $i++;

            $field = substr($field, 1, -1); // Trim "'" from beginning and from end
            $buttonParams = explode("','", $field); // Button params are divided by "','"

            // Button visible for all
            $showButton = true;
            if ($buttonParams[4] != '') {
                $showButton = false;
                $buttonRoles = explode(',', $buttonParams[4]); // Roles are divided by ','
                foreach ($buttonRoles as $v) {
                    if ($v == $_SESSION['mgrRole']) {
                        $showButton = true;
                        break;
                    }
                }
            }

            if (!$showButton) {
                continue;
            }

            // Show custom button
            $controls .= $this->getView(
                'buttons/custom_button_' . $buttonParams[1] . '.tpl'
                , array(
                    'i' => $i,
                    'buttonTitle'    => $buttonParams[0],
                    'buttonParentId' => $buttonParams[2],
                    'buttonTplId'    => $buttonParams[3]
                )
            );
        }
    }

    // Go to Manager button
    if ($this->managerbutton)
    {
        $controls .= $this->getView('buttons/manager_button.tpl');
    }
    // Logout button
    $controls .= $this->getView('buttons/logout_button.tpl', array('docID'=>$docID));

    $css = '
<link rel="stylesheet" type="text/css" href="'.$modx->config['site_url'].'assets/plugins/qm/css/style.css" />
';

    // Autohide toolbar? Default: true
    if (!$this->autohide)
    {
        $css .= '
<style type="text/css">
#qmEditor, #qmEditorClosed { top: 0px; }
</style>
';
    }

    // Insert jQuery and ColorBox in head if needed
    if ($this->loadfrontendjq)
    {
        $head .= '<script src="'.$modx->config['site_url'].$this->jqpath.'" type="text/javascript"></script>';
    }
    if ($this->loadtb)
    {
        $head .= '
<link type="text/css" media="screen" rel="stylesheet" href="'.$modx->config['site_url'].'assets/plugins/qm/css/colorbox.css" />
<script type="text/javascript" src="'.$modx->config['site_url'].'assets/plugins/qm/js/jquery.colorbox-min.js"></script>
';
    }
    // Insert ColorBox jQuery definitions for QuickManager+
    $head .= $this->getView(
        'head/script_colorbox.tpl'
        , array('tbwidth'=>$this->tbwidth, 'tbheight'=>$this->tbheight)
    );

    // Insert QM+ css in head
    $head .= $css;

    // Place QM+ head information in head, just before </head> tag
    $output = preg_replace('~(</head>)~i', $head . '\1', $output);

    // Insert editor toolbar right after <body> tag
    $output = preg_replace(
        '~(<body[^>]*>)~i'
        , '\1' . $this->getView('buttons.tpl', array('buttons'=>$controls))
        , $output
    );

    // Search and create edit buttons in to the content
    if ($this->editbuttons && $access) {
        $output = preg_replace(
            '/<!-- '.$this->editbclass.' ([0-9]+) ([\'|\\"])([^\\"\'\(\)<>!?]+)\\2 -->/'
            , '<span class="'.$this->editbclass.'"><a class="colorbox" href="'.$modx->config['site_url'].'manager/index.php?a=27&amp;id=$1&amp;quickmanager=1&amp;qmrefresh='.$docID.'"><span>$3</span></a></span>'
            , $output);
    }

    // Search and create new document buttons in to the content
    if ($this->newbuttons && $access) {
        $output = preg_replace('/<!-- '.$this->newbclass.' ([0-9]+) ([0-9]+) ([\'|\\"])([^\\"\'\(\)<>!?]+)\\3 -->/', '<span class="'.$this->newbclass.'"><a class="colorbox" href="'.$modx->config['site_url'].'manager/index.php?a=4&amp;pid=$1&amp;quickmanager=1&amp;customaddtplid=$2"><span>$4</span></a></span>', $output);
    }

    // Search and create new document buttons in to the content
    if ($this->tvbuttons && $access) {
        // Set and get user doc groups for TV permissions
        $this->docGroup = '';
        if ($_SESSION['mgrDocgroups']) {
            $this->docGroup = implode(',', $_SESSION['mgrDocgroups']);
        }

        // Create TV buttons and check TV permissions
        $output = preg_replace_callback('/<!-- '.$this->tvbclass.' ([^\\"\'\(\)<>!?]+) -->/', array(&$this, 'createTvButtons'), $output);
    }
}
